Index: src/edu/ucsb/nceas/metacat/AuthSession.java
===================================================================
--- src/edu/ucsb/nceas/metacat/AuthSession.java	(revision 4079)
+++ src/edu/ucsb/nceas/metacat/AuthSession.java	(revision 4080)
@@ -32,6 +32,10 @@
 
 import org.apache.log4j.Logger;
 
+import edu.ucsb.nceas.metacat.service.PropertyService;
+import edu.ucsb.nceas.metacat.util.LDAPUtil;
+import edu.ucsb.nceas.metacat.util.UtilException;
+
 /**
  * A Class that implements session tracking for MetaCatServlet users.
  * User's login data are stored in the session object.
@@ -39,217 +43,230 @@
  */
 public class AuthSession {
 
-  private String authClass = null;
-  private HttpSession session = null;
-  private AuthInterface authService = null;
-  private String statusMessage = null;
-  private static Logger logMetacat = Logger.getLogger(AuthSession.class);
+	private String authClass = null;
+	private HttpSession session = null;
+	private AuthInterface authService = null;
+	private String statusMessage = null;
+	private static Logger logMetacat = Logger.getLogger(AuthSession.class);
 
-  /**
-   * Construct an AuthSession
-   */
-  public AuthSession() throws Exception {
-    // Determine our session authentication method and
-    // create an instance of the auth class
-    MetaCatUtil util = new MetaCatUtil();
-    this.authClass = util.getOption("authclass");
-    this.authService = (AuthInterface)createObject(authClass);
-  }
+	/**
+	 * Construct an AuthSession
+	 */
+	public AuthSession() throws Exception {
+		// Determine our session authentication method and
+		// create an instance of the auth class
+		this.authClass = PropertyService.getProperty("auth.class");
+		this.authService = (AuthInterface) createObject(authClass);
+	}
 
-  /**
-   * Get the new session
-   */
-  public HttpSession getSessions()
-  {
-    return this.session;
-  }
+	/**
+	 * Get the new session
+	 */
+	public HttpSession getSessions() {
+		return this.session;
+	}
 
-  /**
-   * determine if the credentials for this session are valid by
-   * authenticating them using the authService configured for this session.
-   *
-   * @param request the request made from the client
-   * @param username the username entered when login
-   * @param password the password entered when login
-   */
-  public boolean authenticate(HttpServletRequest request,
-                              String username, String password)  {
-    String message = null;
-    try {
-      if ( authService.authenticate(username, password) ) {
+	/**
+	 * determine if the credentials for this session are valid by
+	 * authenticating them using the authService configured for this session.
+	 *
+	 * @param request the request made from the client
+	 * @param username the username entered when login
+	 * @param password the password entered when login
+	 */
+	public boolean authenticate(HttpServletRequest request, String username,
+			String password) {
+		String message = null;
+		try {
+			if (authService.authenticate(username, password)) {
 
-        // getGroups returns groupname along with their description.
-        // hence groups[] is generated from groupsWithDescription[][]
-        String[][] groupsWithDescription =
-            authService.getGroups(username,password,username);
-        String groups[] = new String[groupsWithDescription.length];
-        
-        for(int i=0; i<groupsWithDescription.length; i++){
-          groups[i] = groupsWithDescription[i][0];
-        }
+				// getGroups returns groupname along with their description.
+				// hence groups[] is generated from groupsWithDescription[][]
+				String[][] groupsWithDescription = authService.getGroups(username,
+						password, username);
+				String groups[] = new String[groupsWithDescription.length];
 
-        if(groups == null)
-        {
-          groups = new String[0];
-        }
-        
-        String[] userInfo =
-            authService.getUserInfo(username,password);
-        
-        
-        this.session = createSession(request, username, password, groups, userInfo);
-        String sessionId = session.getId();
-        message = "Authentication successful for user: " + username;
-        this.statusMessage = formatOutput("login", message, sessionId, username, groups, userInfo);
-        return true;
-      } else {
-        message = "Authentication failed for user: " + username;
-        this.statusMessage = formatOutput("unauth_login", message);
-        return false;
-      }
-    } catch ( ConnectException ce ) {
-      message = "Connection to the authentication service failed in " +
-                "AuthSession.authenticate: " + ce.getMessage();
-    } catch ( IllegalStateException ise ) {
-      message = ise.getMessage();
-    }
+				for (int i = 0; i < groupsWithDescription.length; i++) {
+					groups[i] = groupsWithDescription[i][0];
+				}
 
-    this.statusMessage = formatOutput("error_login", message);
-    return false;
-  }
+				if (groups == null) {
+					groups = new String[0];
+				}
 
-  /** Get new HttpSession and store username & password in it */
-  private HttpSession createSession(HttpServletRequest request,
-                                 String username, String password,
-                                 String[] groups, String[] userInfo)
-                      throws IllegalStateException {
+				String[] userInfo = authService.getUserInfo(username, password);
 
-    // get the current session object, create one if necessary
-    HttpSession session = request.getSession(true);
+				this.session = createSession(request, username, password, groups,
+						userInfo);
+				String sessionId = session.getId();
+				message = "Authentication successful for user: " + username;
+				this.statusMessage = formatOutput("login", message, sessionId, username,
+						groups, userInfo);
+				return true;
+			} else {
+				message = "Authentication failed for user: " + username;
+				this.statusMessage = formatOutput("unauth_login", message);
+				return false;
+			}
+		} catch (ConnectException ce) {
+			message = "Connection to the authentication service failed in "
+					+ "AuthSession.authenticate: " + ce.getMessage();
+		} catch (IllegalStateException ise) {
+			message = ise.getMessage();
+		}
 
-    // if it is still in use invalidate and get a new one
-    if ( !session.isNew() ) {
-      logMetacat.info("in session is not new");
-      logMetacat.info("the old session id is : " +
-                                session.getId());
-      logMetacat.info("the old session username : " +
-                                session.getAttribute("username"));
-      session.invalidate();
-      logMetacat.info("in session is not new");
-      session = request.getSession(true);
-    }
-    // store the username, password, and groupname (the first only)
-    // in the session obj for use on subsequent calls to Metacat servlet
-    session.setMaxInactiveInterval(-1);
-    session.setAttribute("username", username);
-    session.setAttribute("password", password);
-    
-    if ( userInfo!=null & userInfo.length == 3 ) {
-        session.setAttribute("name", userInfo[0]);
-        session.setAttribute("organization", userInfo[1]);
-        session.setAttribute("email", userInfo[2]);
-    }
-    
-    if ( groups.length > 0 ) {
-      session.setAttribute("groupnames", groups);
-    }
-     logMetacat.info("the new session id is : " +
-                                session.getId());
-     logMetacat.info("the new session username : " +
-                                session.getAttribute("username"));
-    return session;
-  }
+		this.statusMessage = formatOutput("error_login", message);
+		return false;
+	}
 
-  /**
-   * Get the message associated with authenticating this session. The
-   * message is formatted in XML.
-   */
-  public String getMessage()
-  {
-    return this.statusMessage;
-  }
+	/** Get new HttpSession and store username & password in it */
+	private HttpSession createSession(HttpServletRequest request, String username,
+			String password, String[] groups, String[] userInfo)
+			throws IllegalStateException {
 
-  /**
-   * Get all groups and users from authentication scheme.
-   * The output is formatted in XML.
-   * @param user the user which requests the information
-   * @param password the user's password
-   */
-  public String getPrincipals(String user, String password)
-                throws ConnectException
-  {
-    return authService.getPrincipals(user, password);
-  }
+		// get the current session object, create one if necessary
+		HttpSession session = request.getSession(true);
 
-  /*
-   * format the output in xml for processing from client applications
-   *
-   * @param tag the root element tag for the message (error or success)
-   * @param message the message content of the root element
-   */
-  private String formatOutput(String tag, String message)
-  {
-      return formatOutput(tag, message, null, null, null, null);
-  }
+		// if it is still in use invalidate and get a new one
+		if (!session.isNew()) {
+			logMetacat.info("in session is not new");
+			logMetacat.info("the old session id is : " + session.getId());
+			logMetacat.info("the old session username : "
+					+ session.getAttribute("username"));
+			session.invalidate();
+			logMetacat.info("in session is not new");
+			session = request.getSession(true);
+		}
+		// store the username, password, and groupname (the first only)
+		// in the session obj for use on subsequent calls to Metacat servlet
+		session.setMaxInactiveInterval(-1);
+		session.setAttribute("username", username);
+		session.setAttribute("password", password);
 
-  /*
-   * format the output in xml for processing from client applications
-   *
-   * @param tag the root element tag for the message (error or success)
-   * @param message the message content of the root element
-   * @param sessionId the session identifier for a successful login
-   */
-  private String formatOutput(String tag, String message, 
-		  String sessionId, String username, String[] groups,
-		  String userInfo[])
-  {
-    StringBuffer out = new StringBuffer();
+		if (userInfo != null & userInfo.length == 3) {
+			session.setAttribute("name", userInfo[0]);
+			session.setAttribute("organization", userInfo[1]);
+			session.setAttribute("email", userInfo[2]);
+		}
 
-    out.append("<?xml version=\"1.0\"?>\n");
-    out.append("<" + tag + ">");
-    out.append("\n  <message>" + message + "</message>\n");
-    if (sessionId != null) {
-        out.append("\n  <sessionId>" + sessionId + "</sessionId>\n");
-        
-        if(userInfo != null && userInfo[0]!=null){
-        	out.append("\n<name>\n");
-        	out.append(userInfo[0]);
-        	out.append("\n</name>\n");
-        }
-        
-        // insert <isAdministrator> tag if the user is an administrator
-        if(MetaCatUtil.isAdministrator(username,groups)){
-            out.append("\n  <isAdministrator></isAdministrator>\n");
-        }
-        
-        // insert <isModerator> tag if the user is a Moderator
-        if(MetaCatUtil.isModerator(username,groups)){
-            out.append("\n  <isModerator></isModerator>\n");
-        }
-    }
-    out.append("</" + tag + ">");
+		if (groups.length > 0) {
+			session.setAttribute("groupnames", groups);
+		}
+		logMetacat.info("the new session id is : " + session.getId());
+		logMetacat.info("the new session username : " + session.getAttribute("username"));
+		return session;
+	}
 
-    return out.toString();
-  }
+	/**
+	 * Get the message associated with authenticating this session. The
+	 * message is formatted in XML.
+	 */
+	public String getMessage() {
+		return this.statusMessage;
+	}
 
-  /**
-   * Instantiate a class using the name of the class at runtime
-   *
-   * @param className the fully qualified name of the class to instantiate
-   */
-  private static Object createObject(String className) throws Exception {
+	/**
+	 * Get all groups and users from authentication scheme.
+	 * The output is formatted in XML.
+	 * @param user the user which requests the information
+	 * @param password the user's password
+	 */
+	public String getPrincipals(String user, String password) throws ConnectException {
+		return authService.getPrincipals(user, password);
+	}
 
-    Object object = null;
-    try {
-      Class classDefinition = Class.forName(className);
-      object = classDefinition.newInstance();
-    } catch (InstantiationException e) {
-      throw e;
-    } catch (IllegalAccessException e) {
-      throw e;
-    } catch (ClassNotFoundException e) {
-      throw e;
-    }
-    return object;
-  }
+	/*
+	 * format the output in xml for processing from client applications
+	 *
+	 * @param tag the root element tag for the message (error or success)
+	 * @param message the message content of the root element
+	 */
+	private String formatOutput(String tag, String message) {
+		return formatOutput(tag, message, null, null, null, null);
+	}
+
+	/*
+	 * format the output in xml for processing from client applications
+	 *
+	 * @param tag the root element tag for the message (error or success)
+	 * @param message the message content of the root element
+	 * @param sessionId the session identifier for a successful login
+	 */
+	private String formatOutput(String tag, String message, String sessionId,
+			String username, String[] groups, String userInfo[]) {
+		StringBuffer out = new StringBuffer();
+
+		out.append("<?xml version=\"1.0\"?>\n");
+		out.append("<" + tag + ">");
+		out.append("\n  <message>" + message + "</message>\n");
+		if (sessionId != null) {
+			out.append("\n  <sessionId>" + sessionId + "</sessionId>\n");
+
+			if (userInfo != null && userInfo[0] != null) {
+				out.append("\n<name>\n");
+				out.append(userInfo[0]);
+				out.append("\n</name>\n");
+			}
+
+			try {
+				// insert <isAdministrator> tag if the user is an administrator
+				if (LDAPUtil.isAdministrator(username, groups)) {
+					out.append("\n  <isAdministrator></isAdministrator>\n");
+				}
+			} catch (UtilException ue) {
+				logMetacat.error("Could not determine if user is administrator. "
+						+ "Omitting from xml output: " + ue.getMessage());
+			}
+
+			// insert <isModerator> tag if the user is a Moderator
+			if (LDAPUtil.isModerator(username, groups)) {
+				out.append("\n  <isModerator></isModerator>\n");
+			}
+		}
+		out.append("</" + tag + ">");
+
+		return out.toString();
+	}
+
+	/**
+	 * Instantiate a class using the name of the class at runtime
+	 *
+	 * @param className the fully qualified name of the class to instantiate
+	 */
+	private static Object createObject(String className) throws Exception {
+
+		Object object = null;
+		try {
+			Class classDefinition = Class.forName(className);
+			object = classDefinition.newInstance();
+		} catch (InstantiationException e) {
+			throw e;
+		} catch (IllegalAccessException e) {
+			throw e;
+		} catch (ClassNotFoundException e) {
+			throw e;
+		}
+		return object;
+	}
+	
+	/**
+	 * Instantiate a class using the name of the class at runtime
+	 *
+	 * @param className the fully qualified name of the class to instantiate
+	 */
+	private static Object createObject(String className, String orgName) throws Exception {
+
+		Object object = null;
+		try {
+			Class classDefinition = Class.forName(className);
+			object = classDefinition.newInstance();
+		} catch (InstantiationException e) {
+			throw e;
+		} catch (IllegalAccessException e) {
+			throw e;
+		} catch (ClassNotFoundException e) {
+			throw e;
+		}
+		return object;
+	}
 }
Index: src/edu/ucsb/nceas/metacat/DBTransform.java
===================================================================
--- src/edu/ucsb/nceas/metacat/DBTransform.java	(revision 4079)
+++ src/edu/ucsb/nceas/metacat/DBTransform.java	(revision 4080)
@@ -52,13 +52,11 @@
 import org.w3c.dom.NodeList;
 import org.w3c.dom.Document;
 import org.w3c.dom.Node;
-import org.w3c.dom.NodeList;
 import org.w3c.dom.DocumentType;
 import org.xml.sax.SAXException;
 import org.xml.sax.InputSource;
 import org.apache.xerces.dom.DocumentTypeImpl;
 import org.apache.xpath.XPathAPI;
-import org.w3c.dom.NamedNodeMap;
 
 /*
 import oracle.xml.parser.v2.XSLStylesheet;
@@ -73,6 +71,11 @@
 import org.w3c.dom.Element;
 import org.xml.sax.SAXException;
 
+import edu.ucsb.nceas.metacat.service.PropertyService;
+import edu.ucsb.nceas.metacat.util.MetaCatUtil;
+import edu.ucsb.nceas.metacat.util.SystemUtil;
+import edu.ucsb.nceas.utilities.PropertyNotFoundException;
+
 import java.util.Properties;
 
 
@@ -100,15 +103,14 @@
   public DBTransform()
                   throws IOException,
                          SQLException,
-                         ClassNotFoundException
+                         ClassNotFoundException,
+                         PropertyNotFoundException
   {
-    //this.conn = conn;
-    util = new MetaCatUtil();
-    configDir = util.getOption("config-dir");
-    defaultStyle = util.getOption("default-style");
-    httpServer = util.getOption("httpserver");
-    contextURL = util.getOption("httpserver")+"/"+util.getOption("context");
-    servletURL = util.getOption("httpserver")+util.getOption("servletpath");
+    configDir = SystemUtil.getStyleSkinsDir();
+    defaultStyle = PropertyService.getProperty("application.default-style");
+    httpServer = SystemUtil.getServerURL();
+    contextURL = SystemUtil.getContextURL();
+    servletURL = SystemUtil.getServletURL();
   }
 
   /**
@@ -165,7 +167,7 @@
       }
       catch (Exception e)
       {
-    	  logMetacat.error(xslSystemId + ": Error transforming document in " +
+        pw.println(xslSystemId + ": Error transforming document in " +
                    "DBTransform.transformXMLDocument: " +
                    e.getMessage());
 
@@ -247,7 +249,7 @@
       }
       catch (Exception e)
       {
-    	  logMetacat.error(xslSystemId + ": Error transforming document in " +
+        pw.println(xslSystemId + ": Error transforming document in " +
                    "DBTransform.transformXMLDocument: " +
                    e.getMessage());
 
@@ -308,7 +310,7 @@
         }
         
         //set up the default params (can be overridden by the passed in params)
-        String cgiPrefix = MetaCatUtil.getOption("cgi-prefix");
+        String cgiPrefix = SystemUtil.getCGI_URL();
         logMetacat.debug("cgi-prefix=" + cgiPrefix);
         logMetacat.debug("httpServer=" + httpServer);
         logMetacat.debug("contextURL=" + contextURL);
@@ -528,10 +530,6 @@
      } else {
         try {
 
-          // Open a connection to the database
-          /*MetaCatUtil   util = new MetaCatUtil();
-          Connection dbconn = util.openDBConnection();*/
-
           // Create a test document
           StringBuffer testdoc = new StringBuffer();
           testdoc.append("<?xml version=\"1.0\"?>");
Index: src/edu/ucsb/nceas/metacat/QueryGroup.java
===================================================================
--- src/edu/ucsb/nceas/metacat/QueryGroup.java	(revision 4079)
+++ src/edu/ucsb/nceas/metacat/QueryGroup.java	(revision 4080)
@@ -30,6 +30,7 @@
 package edu.ucsb.nceas.metacat;
 
 import edu.ucsb.nceas.dbadapter.*;
+import edu.ucsb.nceas.metacat.util.MetaCatUtil;
 
 import java.io.*;
 import java.util.Hashtable;
Index: src/edu/ucsb/nceas/metacat/DBSAXHandler.java
===================================================================
--- src/edu/ucsb/nceas/metacat/DBSAXHandler.java	(revision 4079)
+++ src/edu/ucsb/nceas/metacat/DBSAXHandler.java	(revision 4080)
@@ -37,8 +37,11 @@
 import java.util.Stack;
 import java.util.Vector;
 
+import edu.ucsb.nceas.metacat.service.PropertyService;
+import edu.ucsb.nceas.metacat.util.MetaCatUtil;
 import edu.ucsb.nceas.morpho.datapackage.Triple;
 import edu.ucsb.nceas.morpho.datapackage.TripleCollection;
+import edu.ucsb.nceas.utilities.PropertyNotFoundException;
 
 import org.apache.log4j.Logger;
 import org.xml.sax.Attributes;
@@ -226,35 +229,33 @@
     }
 
     /** SAX Handler that receives notification of end of the document */
-    public void endDocument() throws SAXException
-    {
-        logMetacat.info("end Document");
-        // Starting new thread for writing XML Index.
-        // It calls the run method of the thread.
+	public void endDocument() throws SAXException {
+		logMetacat.info("end Document");
+		// Starting new thread for writing XML Index.
+		// It calls the run method of the thread.
 
-        //if it is data package insert triple into relationtion table;
-        if (doctype != null
-                && MetaCatUtil.getOptionList(
-                        MetaCatUtil.getOption("packagedoctype")).contains(
-                        doctype) && hasTriple && !isRevisionDoc) {
-            try {
-                //initial handler and write into relationdb only for xml-documents
-                if (!isRevisionDoc)
-                {
-                  RelationHandler handler = new RelationHandler(docid, doctype,
-                        connection, tripleList);
-                }
-            } catch (Exception e) {
-                logMetacat.error(
-                        "Failed to write triples into relation table"
-                                + e.getMessage());
-                throw new SAXException(
-                        "Failed to write triples into relation table "
-                                + e.getMessage());
-            }
-        }
-    }
+		try {
+			// if it is data package insert triple into relationtion table;
+			if (doctype != null
+					&& MetaCatUtil.getOptionList(
+							PropertyService.getProperty("packagedoctype")).contains(
+							doctype) && hasTriple && !isRevisionDoc) {
 
+				// initial handler and write into relationdb only for
+				// xml-documents
+				if (!isRevisionDoc) {
+					RelationHandler handler = new RelationHandler(docid, doctype,
+							connection, tripleList);
+				}
+			}
+		} catch (Exception e) {
+			logMetacat.error("Failed to write triples into relation table"
+					+ e.getMessage());
+			throw new SAXException("Failed to write triples into relation table "
+					+ e.getMessage());
+		}
+	}
+
     /** SAX Handler that is called at the start of Namespace */
     public void startPrefixMapping(String prefix, String uri)
             throws SAXException
@@ -418,20 +419,26 @@
         }
 
         // Add the node to the stack, so that any text data can be
-        // added as it is encountered
-        nodeStack.push(currentNode);
-        // Add the node to the vector used by thread for writing XML Index
-        nodeIndex.addElement(currentNode);
-        // start parsing triple
-        if (doctype != null
-                && MetaCatUtil.getOptionList(
-                        MetaCatUtil.getOption("packagedoctype")).contains(
-                        doctype) && localName.equals("triple")) {
-            startParseTriple = true;
-            hasTriple = true;
-            currentTriple = new Triple();
-        }
-    }    
+		// added as it is encountered
+		nodeStack.push(currentNode);
+		// Add the node to the vector used by thread for writing XML Index
+		nodeIndex.addElement(currentNode);
+		// start parsing triple
+		try {
+			if (doctype != null
+					&& MetaCatUtil.getOptionList(
+							PropertyService.getProperty("packagedoctype")).contains(doctype)
+					&& localName.equals("triple")) {
+				startParseTriple = true;
+				hasTriple = true;
+				currentTriple = new Triple();
+			}
+		} catch (PropertyNotFoundException pnfe) {
+			pnfe.printStackTrace();
+			throw (new SAXException("Error in DBSaxHandler.startElement " + action, pnfe));
+		}
+	}               
+    
 
     /** SAX Handler that is called for each XML text node */
     public void characters(char[] cbuf, int start, int len) throws SAXException
